<template>
  <div>
    <modal v-if="modal" title="Изменение балла" @close="changeModalState">
      <issued-grade-change @close="changeModalState"/>
    </modal>
    <div class="wp-title wp-12">Выставленные баллы</div>
    <nav-bar v-model="search" @action="changeModalState"/>
    <masonry class="wp-12"
      :columnClass="MasonryColumnClass"
      :cols="MasonryColumns"
      :gutter="MasonryGutter">
      <card v-for="(gradeChange, index) in filteredIssuedGradeChanges" :key="index"
        :title="gradeChange.text" :menuItems="cardMenuItems"
        delete @delete="removeGradeChange(gradeChange.id)">
        <template v-slot:info>
          <div class="wp-layout">
            <div class="wp-12 wp-field">
              <div class="wp-field__title">
                Причина
              </div>
              <div class="wp-field__content">
                <div class="wp-field__text">
                  {{ gradeChange.text }}
                </div>
              </div>
            </div>
            <div class="wp-12 wp-field">
              <div class="wp-field__title">
                Пользователь
              </div>
              <div class="wp-field__content">
                <div class="wp-field__text">
                  {{ memberByID[gradeChange.user] }}
                </div>
              </div>
            </div>
          </div>
        </template>
        <template v-slot:grade_changes>
          <grade-changes-table :grade_changes="gradeChange.grade_changes"/>
        </template>
      </card>
    </masonry>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';

import { MasonryGutter, MasonryColumnClass, MasonryColumns } from '@/shared';

import Card from '@/components/Card.vue';
import GradeChangesTable from '@/components/card/GradeChangesTable.vue';
import NavBar from '@/components/NavBar.vue';

import Modal from '@/components/modal/Modal.vue';
import IssuedGradeChange from '@/components/modal/user/IssuedGradeChange.vue';

export default {
  name: 'IssuedGradeChanges',
  components: {
    NavBar,
    Card,
    GradeChangesTable,
    Modal,
    IssuedGradeChange,
  },
  data() {
    return {
      MasonryGutter,
      MasonryColumns,
      MasonryColumnClass,
      modal: false,
      search: '',
      cardMenuItems: [
        {
          text: 'Информация',
          prop: 'info',
        },
        {
          text: 'Изменения',
          prop: 'grade_changes',
        },
      ],
    };
  },
  computed: {
    ...mapState('user', ['issued_grade_changes']),
    ...mapGetters('organization', ['memberByID', 'categoryByID']),
    filteredIssuedGradeChanges() {
      return this.issued_grade_changes.filter(gradeChange => gradeChange.text.toLowerCase().indexOf(
        this.search.toLowerCase(),
      ) !== -1);
    },
  },
  methods: {
    ...mapActions('user', [
      'getIssuedGradeChanges',
      'deleteGradeChange',
    ]),
    ...mapActions('organization', [
      'getOrganizationMembers',
      'getOrganizationCategories',
    ]),
    changeModalState(category = null) {
      this.editedCategory = category;
      this.modal = !this.modal;
    },
    async removeGradeChange(gradeChangeGroupID) {
      try {
        await this.deleteGradeChange(gradeChangeGroupID);
        this.$toasted.success('Балл изменен');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    this.getOrganizationMembers();
    this.getOrganizationCategories();
    this.getIssuedGradeChanges();
  },
};
</script>

<style lang="scss" scoped>
</style>
